<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO;
use \Setforms2\Shared\ORM\DateTime;
use \Doctrine\ORM\EntityManager;

class Pla06900LiberacaoDeCardapioParaProducao extends \Teknisa\GER\Controllers\TeknisaCrud {
    private   $entityManager;
    protected $crudService;
    protected $dataSourceManager;
    protected $environment;
    protected $connection;
    protected $parameterBag;
    protected $liberacaoDeCardapioParaProducaoService;
    protected $dataSourceParamBag;
    protected $nrlista_fili;
    protected $nrlista_filiserv;
    protected $params;
    protected $idutcardpadr;
    protected $grupoperador;
    protected $libCardapio;
    protected $PlaValidacaoCardapio;  
    
    public function __construct($crudService, $parameterBag, $entityManager, Manager $dataSourceManager, Environment $environment, $connection, $dataSourceParamBag, $liberacaoDeCardapioParaProducaoService, $util, $PlaValidacaoCardapio) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->entityManager = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->connection = $connection;
        $this->dataSourceParamBag = $dataSourceParamBag;
        $this->liberacaoDeCardapioParaProducaoService = $liberacaoDeCardapioParaProducaoService;
        $this->util = $util;
        $this->PlaValidacaoCardapio = $PlaValidacaoCardapio;
	}
	
	public function getAllAgregadas($central) {
        $arrayAgregadas = $this->liberacaoDeCardapioParaProducaoService->getAllAgregadas($central);
        return $arrayAgregadas;
	}
	
	public function handleBloqueioLibCardProd(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $central = substr($row["NMFILIAL"], 0, 4);
            
            if($row["NMFILIALAGREGADA"] == "" || $row["NMFILIALAGREGADA"] == []) {
                $row["NMFILIALAGREGADA"] = $this->getAllAgregadas($central);
            }
            
            if(is_array($row["NMFILIALAGREGADA"]) && count($row["NMFILIALAGREGADA"]) > 0) {
                $agregadas = array_map(function($agregada) {
                    return $agregada["CDFILIAL"];
                }, $row["NMFILIALAGREGADA"]);
            }
            
            $agregadas = (!isset($agregadas)) ? [] : $agregadas;
            
            if($row["NMSERVICO"] == "" || $row["NMSERVICO"] == []) {
                $row["NMSERVICO"] = $this->liberacaoDeCardapioParaProducaoService->getAllServices($central, implode("_", $agregadas));
            }
            $arrayServicos = $row["NMSERVICO"];
            
            foreach($arrayServicos as $servico) {
                $this->liberacaoDeCardapioParaProducaoService->updateCardaMes($servico["CDFILIAL"], $servico["CDSERVFILI"], $row["FORMATEDDTCARDAPIO"]);
                $this->liberacaoDeCardapioParaProducaoService->deleteCtrlAprovCard($servico["CDFILIAL"], $servico["CDSERVFILI"], $row["FORMATEDDTCARDAPIO"]);
            }
            
            $response->addDataset(new DataSource\DataSet('RETORNO', ["SUCESSO_BLOQUEIO"]));
        } catch (\Exception $e) {
	        $response->addDataset(new DataSource\DataSet('RETORNO', ["FALHA_OPERACAO_BLOQUEIO"]));
	    }
	  
	}
	
	public function handleLibCardProd(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();  
            $servicosComRestricao = [];
            $central = substr($row["NMFILIAL"], 0, 4);
            $agregadas = [];
            $servicosLiberados = [];
            
            if($row["NMFILIALAGREGADA"] == "" || $row["NMFILIALAGREGADA"] == []) {
                $row["NMFILIALAGREGADA"] = $this->getAllAgregadas($central);
            }
            
            if(is_array($row["NMFILIALAGREGADA"]) && count($row["NMFILIALAGREGADA"]) > 0) {
                $agregadas = array_map(function($agregada) {
                    return $agregada["CDFILIAL"];
                }, $row["NMFILIALAGREGADA"]);
            }
            
            if($row["NMSERVICO"] == "" || $row["NMSERVICO"] == []) {
                $row["NMSERVICO"] = $this->liberacaoDeCardapioParaProducaoService->getAllServices($central, implode("_", $agregadas));
            }
            
            $arrayCdChave = array_map(function($cdChave) {
                return $cdChave["CDCHAVE"];
            }, $row["NMSERVICO"]);
            
            $nrLista = $this->util->insertLista($arrayCdChave);
            
            $row["NRCONSPLAN"] = $this->liberacaoDeCardapioParaProducaoService->executaConsplanGeral($row, $nrLista);
            
            foreach($row["NMSERVICO"] as $servico) {
                $params = [
                  "CDFILIAL"                        => $servico["CDFILIAL"],
                  "CDSERVFILI"                      => $servico["CDSERVFILI"],
                  "IDTIPORESTRICAO"                 => 'CONTRATO',
                  "DATA_INICIAL"                    => $row["FORMATEDDTCARDAPIO"],
                  "DATA_FINAL"                      => $row["FORMATEDDTCARDAPIOEND"],
                  "PRIMEIRO_ULTIMO_DIA_SEMANA"      => $row["PRIMEIRO_ULTIMO_DIA_SEMANA"]
                ];
    	        
                //valida Restricoes Contratuais 
        	    $validacao = $this->PlaValidacaoCardapio->validaRestricoesContratuais($params);
        	    $existeRestricao = (
        	        !empty($validacao['FREQUENCIA_PRATO']) || 
        	        !empty($validacao['FREQUENCIA_GRUPO_PRATO']) || 
        	        !empty($validacao['FREQUENCIA_PRODUTO_GRUPO_PRATO']) || 
        	        !empty($validacao['RESTRICAO_PRODUTO_GRUPO_PRATO']) || 
        	        !empty($validacao['FREQUENCIA_GRUPO_PRATO_OPCAO']) || 
        	        !empty($validacao['LIMITE_PER_CAPITA_POR_SERVICO'])
        	    );
        	    $servicoLiberado = "";
        	    $mediaEMeta = $this->liberacaoDeCardapioParaProducaoService->retornaMediaEMeta($row, $servico);
        	    $existeCustPadr = $this->liberacaoDeCardapioParaProducaoService->retornCustPadr($row, $servico);
        	    $valorMeta = (isset($mediaEMeta[0])) ? $mediaEMeta[0]["META"] : (isset($existeCustPadr[0]) ? $existeCustPadr[0]["VRCUSTPADR"] : 0);
        	    $verificaServicoLiberado = $this->liberacaoDeCardapioParaProducaoService->verificaServicoLiberado($row, $servico);
        	    
        	    if(count($verificaServicoLiberado) > 0) {
                    $servicoLiberado = $verificaServicoLiberado[0]["IDCARDLIBCENT"];
        	    }
        	    
        	    $media = (isset($mediaEMeta[0])) ? $mediaEMeta[0]["MEDIA"] : 0;
        	    $meta = $valorMeta ? $valorMeta : 0;     
        	    
        	    if($existeRestricao || ($media > $meta) ||  $meta == 0 || ($media == 0 && $meta > 0) || ($media == 0 && $meta == 0) || ($servicoLiberado == 'N' || $servicoLiberado == NULL)) {
                    $mediaEMeta[0]["EXISTE_RESTRICAO"] = [
                        "CDFILIAL"          => $servico["CDFILIAL"],
                        "NMFILIAL"          => $servico["NMFILIAL"],
                        "CDSERVFILI"        => $servico["CDSERVFILI"],
                        "NMSERVICO"         => $servico["NMSERVICO"],
                        "IDERESTRICAO"      => ($existeRestricao) ? "S" : "N",
                        "IDLIBERADO"        => ($servicoLiberado == "S") ? "S" : "N",
                        "META"              => $meta,
                        "MEDIA"             => $media
                    ];
                    array_push($servicosComRestricao, $mediaEMeta[0]["EXISTE_RESTRICAO"]);
        	    } else {
            	   $servLiberado = [
                    "CDFILIAL" => $servico["CDFILIAL"],
                    "CDSERVFILI" => $servico["CDSERVFILI"],
                    "VRCUSTO" => $media
            	   ];
            	   
            	   array_push($servicosLiberados, $servLiberado);
        	    }
            }
            
    	    if(count($servicosComRestricao) > 0) {
    	        return $response->addDataset(new DataSource\DataSet('SERVICO_RESTRICAO', $servicosComRestricao));
    	    }
    	    
            // LIBERAÇÃO DE CARDAPIO
            $this->liberacaoCardapioProducao($row, $servicosLiberados);
            
            $response->addDataset(new DataSource\DataSet('SUCESSO_LIB_CARD', ['SUCESSO_LIB_CARD']));    	        
            
        } catch (\Exception $e) {
	        $response->addDataset(new DataSource\DataSet('RETORNO', ["FALHA_LIBERACAO_CARDAPIO"]));
	        $response->addDataset(new DataSource\DataSet('erro', [$e->getMessage()]));
	    }
	}	
	
	public function liberacaoCardapioProducao($row, $servicosLiberados) {
        foreach($servicosLiberados as $servico) {
            $this->liberacaoDeCardapioParaProducaoService->updateCardaMesLibCardProd($servico["CDFILIAL"], $servico["CDSERVFILI"], $row["FORMATEDDTCARDAPIO"]);            
            $verificaVrCustoLib = $this->liberacaoDeCardapioParaProducaoService->verificaVrCustoLib($servico["CDFILIAL"], $servico["CDSERVFILI"], $row["FORMATEDDTCARDAPIO"]);
	        
	        if(count($verificaVrCustoLib) > 0) {
	            $this->liberacaoDeCardapioParaProducaoService->updateCtrlAprovCard($row, $servico);
	        } else {
	            $this->liberacaoDeCardapioParaProducaoService->insertCtrAprovCard($row, $servico);
	        }
        }        	        
    }
	
}